/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, window, location, CSInterface, SystemPath, themeManager*/

(function () {
  'use strict';

  var csInterface = new CSInterface ();
  init ();

  function init () {

    themeManager.init ();

    loadJSX ("json2.js");

    var btnNames = [],
        divBtns  = document.getElementById('btns'),
        i;

    // load names from cfg-file
    var cfgPath = csInterface.getSystemPath (SystemPath.EXTENSION) + "/jsx/cfg.cfg";
    csInterface.evalScript ('rCfg("' + cfgPath + '")', function (result) {
      btnNames = JSON.parse(result);

      for (i = 0; i < btnNames.length; i++) {
        addBtn (btnNames[i]);
      }
    });

    $ ("#btn_addBtn").click (function () {
      csInterface.evalScript ('addBtn("' + csInterface.getSystemPath (SystemPath.EXTENSION) + '" )',
        function (result) {
          if (result.length != 0) {
            addBtn (result);
          }
        });
    });
    $ ("#btn_killCEP").click (function () {
      csInterface.evalScript ('killCEP()');
    });
    $ ("#btn_reload").click (function () {
      reloadPanel ();
    });
    $ ("#btn_source").click (function () {
      var extPath = csInterface.getSystemPath (SystemPath.EXTENSION)
      csInterface.evalScript ('openJsxFolder("' + extPath + '")');
    });

    /** * * * * * * * * * * * *
     * * * jsxSet library * * *
     * * * * * * * * * * * * **/

    function addBtn (btnName) {
      if (btnName.length == 0) return;

      var btn = document.createElement('input');
      btn.setAttribute('type', 'image');
      btn.setAttribute('class', 'btn');
      btn.setAttribute('src', 'img/user/' + btnName + '.png');
      btn.setAttribute('title', btnName);
      btn.setAttribute('name', btnName);
      btn.setAttribute('id', 'btn_' + btnName);

//      btn.className = 'btn';

      btn.addEventListener('click', function () {
        loadUserJSX (btnName + '.jsx');
      })
      btn.oncontextmenu = function () {
        var delName    = this.name,
            extPath    = csInterface.getSystemPath (SystemPath.EXTENSION),
            btnToDel   = document.getElementById('btn_' + btnName),
            confirmDel = confirm ('Delete script: ' + delName + '?');
        if (confirmDel) {
          csInterface.evalScript ('delBtn("' + extPath + '","' + btnName + '" )', function (result) {
            btnToDel.remove();
            //alert (result);
          });
        }
        return false;
      }

      divBtns.appendChild(btn);
    }

  }

  /** * * * * * * * * * *
   * * * NATIVE LIB * * *
   * * * * * * * * * * **/
  // Reloads extension panel
  function reloadPanel () {
    location.reload ();
  }

  function loadJSX (fileName) {
    var extensionRoot = csInterface.getSystemPath (SystemPath.EXTENSION) + "/jsx/";
    csInterface.evalScript ('$.evalFile("' + extensionRoot + fileName + '")');
  }

  function loadUserJSX (fileName) {
    var extensionRoot = csInterface.getSystemPath (SystemPath.EXTENSION) + "/jsx/user/";
    csInterface.evalScript ('$.evalFile("' + extensionRoot + fileName + '")');
  }

} ());
    
